<template>
    <div class="container">
        <div class="margin-top-50"></div>
        <div class="row">
            <div class="columns twelve block-credit-rating" v-if="isCreditRatingReady || isRequestCreditRatingDataError || showCreditRatingData">
                <div v-if="isCreditRatingReady">
                    <div class="content">
                        <button v-if="showCreditRatingData"
                                ref="toHistoryButton"
                                class="white back-button"
                                @click="$emit('toHistory')"
                        >
                            История
                        </button>
                        <template v-else>
                            <h3 class="main-header">Кредитный рейтинг</h3>
                            <div class="steps">
                                <div class="step pass">
                                    <span>1</span>
                                    <div>Заполнение анкеты</div>
                                </div>
                                <div class="step pass">
                                    <span>2</span>
                                    <div>Оплата</div>
                                </div>
                                <div class="step pass">
                                    <span>3</span>
                                    <div>Кредитный рейтинг</div>
                                </div>
                            </div>
                        </template>
                        <div class="tachometer white-block">
                            <div class="row padding">
                                <div class="columns six">
                                    <div class="strong">Ваш кредитный рейтинг:</div>
                                    <div class="rate">{{ratingData.value}} баллов</div>
                                </div>
                                <div class="columns six">
                                    <div class="strong">{{ratingData.value_description}}</div>
                                    <div class="lite">
                                        ({{getValueDecorateMod('value')}} баллов)
                                    </div>
                                    <div>
                                        <div class="slider">
                                            <div class="color" :style="{
                                            width: sliderFillRatingPercentValue + '%',
                                        }"></div>
                                            <div class="bumper"></div>
                                            <div class="color2" :style="{
                                            width: sliderEmptyRatingPercentValue + '%',
                                        }"></div>
                                        </div>
                                        <div class="row">
                                            <div class="column liner"></div>
                                        </div>
                                        <div class="range">
                                            <span>0</span>
                                            <span>200</span>
                                            <span>400</span>
                                            <span>600</span>
                                            <span>800</span>
                                            <span>1 000</span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="white-block block-credit-rating-result">
                            <div class="padding">
                                <h3>Информация о вашем кредитном рейтинге</h3>
                            </div>
                            <hr/>
                            <div class="padding">

                                <div class="row auto-height">
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('socio_demographic_code')">
                                            <!--{{ratingData.socio_demographic_code}}-->
                                            <div class="face"></div>
                                        </div>
                                        <h3>Социодемографические показатели</h3>
                                        <p>{{ratingData.socio_demographic_description}}</p>

                                    </div>
                                    <div class="columns four item">
                                        <div :class="['small-font', getValueDecorateMod('loan_payments_percent')]">{{ratingData.loan_payments_percent}}%</div>
                                        <h3>Ежемесячные платежи по кредитам</h3>
                                        <p>от вашего дохода</p>
                                    </div>
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('loan_load_code')">
                                            <!--{{ratingData.loan_load_code}}-->
                                            <div class="face"></div>
                                        </div>
                                        <h3>Кредитная нагрузка</h3>
                                        <p>
											в {{ratingData.loan_load_description_short}} зоне
                                        </p>
                                    </div>
                                </div>
                                <div class="warning-block">
                                    {{ratingData.loan_load_description}}
                                </div>
                                <div class="row block-credit-rating-result">
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('loans_overdue')">
                                            {{ratingData.loans_overdue}}
                                        </div>
                                        <h3>
                                            В настоящее время у вас {{$helpers.plural(ratingData.loans_overdue, ['просрочен', 'просрочено', 'просрочено'])}} {{ratingData.loans_overdue}} {{$helpers.plural(ratingData.loans_overdue, ['кредит', 'кредита', 'кредитов'])}}

                                        </h3>
                                        <p>
                                            {{ratingData.loans_overdue_description}}
                                        </p>
                                    </div>

                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('loan_overdue_max_day')">{{ratingData.loan_overdue_max_day}}</div>
                                        <h3>Максимальная текущая глубина просрочки {{ratingData.loan_overdue_max_day}} дней</h3>
                                    </div>
                                </div>
                                <div class="warning-block">
                                    {{ratingData.loans_paid_description}}
                                </div>
                                <div class="row block-credit-rating-result">
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('microloans_active')">{{ratingData.microloans_active}}</div>
                                        <h3>Количество активных микрозаймов</h3>
                                    </div>
                                    <div class="columns four item">
                                        <div class="gray">{{ratingData.microloans_last_six_months}}</div>
                                        <h3>Количество микрозаймов за последние 6 месяцев</h3>
                                    </div>
                                </div>
                                <div class="warning-block">
                                    Активное и ответственное пользование микрозаймами - это отличный способ приобрести первичную кредитную историю или улучшить подпорченную.
                                </div>
                                <div class="row block-credit-rating-result">
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('loan_last_month_requests')">{{ratingData.loan_last_month_requests}}</div>
                                        <h3>В течение последнего месяца Вы обращались за кредитами</h3>
                                        <p>Слишком частая заинтересованность в получении кредитов может снизить шансы на положительное решение.</p>
                                    </div>
                                    <div class="columns four item">
                                        <div :class="getValueDecorateMod('loans_paid')">{{ratingData.loans_paid}}</div>
                                        <h3>
                                            количество выплаченных (закрытых) вами кредитов
                                        </h3>
                                        <p>{{ratingData.loans_paid_description}}</p>
                                    </div>
                                    <div class="columns four item">
                                        <div class="gray">{{ratingData.loan_last_paid_days}}</div>
                                        <h3>Последнее погашение кредита состоялось</h3>
                                        <p>Недавно погашенные кредиты свидетельствуют о прочности Вашего текущего финансового положения.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="center">
                            <SpecifyMail header="rating"
                                         v-bind="{
                                            ratingData,
                                         }"
                            >
                                <template slot="header">
                                    <h6 class="specify-mail__header-title">Скачать отчет в PDF</h6>
                                </template>
                            </SpecifyMail>
                        </div>
                    </div>
                </div>

                <div v-if="isRequestCreditRatingDataError">
                    <div class="warning-block white-block">
                        Произошла ошибка запроса на сервер.
                    </div>
                </div>

            </div>
            <div v-else>
                <div class="white-block">
                    <div class="padding">
                        <div v-if="isCreditRatingLoadOvertime" class="warning-block">
                            Истек период ожидания. Кредитный рейтинг будет доставлен вам на e-mail по мере готовности
                        </div>
                        <loader v-else
                                ref="loader"
                                v-bind="{
                              name: 'creditRating',
                              isShow: true,
                              waitingTitle: 'Загрузка кредитного рейтинга',
                              caption: `Сбор информации по Вашему кредитному рейтингу может занять более ${storeCreditRatingState.getCreditRatingByGuidTimeoutMs / 60000}-х минут. Результат будет доставлен на Ваш e-mail.`,
                              backgroundColor: 'transparent',
                        }"
                                class="loader"
                        />
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
	import SpecifyMail from "../SpecifyMail";
	import Loader from '@/components/Loader';

	import getCreditRatingByGuid from './methods/getCreditRatingByGuid';
	import getCreditRating from './methods/getCreditRating';
    import getValueDecorateMod from './methods/getValueDecorateMod';

	export default {
		name: "CreditRating",

		components: {
			SpecifyMail,
			Loader,
		},

        props: {
			showCreditRatingData: {
				type: Object,
            },
        },

		data () {
			return {
				isRequestCreditRatingDataError: false,
				timeoutBeforeShowResultEmail: null,
				isCreditRatingLoadOvertime: false,
				timeoutBeforeShowResultEmailMin: 3,
				lastCreditRatingRequest: null,
				maxRatingPoints: 1000,
				ratingData: {
					code: null,
					date: '',
					first_name: '',
					hash: '',
					id: 0,
					last_name: '',
					loan_last_month_requests: 0,
					loan_last_paid_days: 0,
					loan_load_code: 0,
					loan_load_description: '',
					loan_load_description_short: '',
					loan_overdue_max_day: 0,
					loan_payments_percent: 0,
					loans_overdue: 0,
					/*Поздравляем! Вы ответственный заемщик.*/
					/*Это практически исключает возможность получения Вами кредита в банке, но у Вас остается шанс получить займ в микрофинансовой организации.*/
					/*Это негативный фактор, исключающий  возможность получения Вами кредита в банке и серьезно снижающий Ваши шансы на получение займа в микрофинансовой организации.*/
					loans_overdue_description: '',
					loans_paid: 0,
					/*"Это негативный фактор. Вам нужно доказать Вашу способность исполнять обязательства по кредитам для улучшения кредитной истории."*/
					/*"Пока немного. Погасите больше кредитов для улучшения кредитной истории."*/
					/*"Это положительный фактор. Вы доказали свою  способность исполнять обязательства по кредитам."*/
					loans_paid_description: '',
					microloans_active: 0,
					microloans_last_six_months: 0,
					middle_name: '',
					socio_demographic_code: 0,
					socio_demographic_description: '',
					status: 0,
					user_id: null,
					value: 0,
					value_description: '',
				},
				valuesDecorateModsRanges: {
					/*балы*/
					value: {
						1: '1 – 250',
						251: '251 – 689',
						690: '690 – 1000',
					},
                    /*Максимальная текущая глубина просрочки дней*/
					loan_overdue_max_day: {
						0: 'green',
						1: 'yellow',
						31: 'red',
					},
                    /*Социодемографические показатели*/
					socio_demographic_code: {
						bad: 'green',
						middle: 'yellow',
						good: 'red',
					},
                    /*Ежемесячные платежи по кредитам*/
					loan_payments_percent: {
						0: 'green',
						21: 'yellow',
						41: 'red',
					},
                    /*Кредитная нагрузка*/
					loan_load_code: {
						comfort: 'green',
						balanced: 'yellow',
						heavy: 'red',
					},
                    /*в настоящее время у вас просрочено кредита*/
					loans_overdue: {
						0: 'green',
						1: 'yellow',
						3: 'red',
					},
                    /*Количество активных микрозаймов*/
					microloans_active: {
						0: 'green',
						1: 'yellow',
					},
                    /*Количество микрозаймов за последние 6 месяцев*/

                    /*В течение последнего месяца Вы обращались за кредитами*/
					loan_last_month_requests: {
						0: 'green',
						3: 'yellow',
					},
                    /*Количество выплаченных (закрытых) Вами кредитов*/
					loans_paid: {
						/*"Это негативный фактор. Вам нужно доказать Вашу способность исполнять обязательства по кредитам для улучшения кредитной истории."*/
						0: 'red',
                        /*"Пока немного. Погасите больше кредитов для улучшения кредитной истории."*/
						1: 'yellow',
                        /*"Это положительный фактор. Вы доказали свою  способность исполнять обязательства по кредитам."*/
						3: 'green',
					}
				},
			}
		},

		computed: {
			storeCreditRatingState() {
				return this.$store.state.creditRating;
			},
			sliderFillRatingPercentValue() {
				return this.ratingData.value / this.maxRatingPoints * 100;
			},
			sliderEmptyRatingPercentValue() {
				return 100 - this.sliderFillRatingPercentValue;
			},
			isCreditRatingReady() {
				return this.ratingData.status === 2;
            },
		},

		methods: {
			getCreditRatingByGuid,
			getCreditRating,
			getValueDecorateMod,
		},

		created () {
			/*если данные уже райтинга существуют и были переданы через свойство*/
			if(this.showCreditRatingData) {
				this.ratingData = this.showCreditRatingData;
            } else {
				/*получить данные кредитного рейтинга*/
				this.getCreditRating();
            }
		},

        mounted() {
			/*если данные уже райтинга существуют и были переданы через свойство*/
			if(this.showCreditRatingData) {
				this.$helpers.scroll(this.$refs.toHistoryButton);
			}
        },

        beforeDestroy() {
			clearTimeout(this.timeoutBeforeShowResultEmail);
		},
	}
</script>

<style lang="scss" scoped>
    .columns.four.item {
        word-break: break-word;
    }
    .loader {
        position: relative;
    }
	.back-button {
		background:#fff url(/lk/static/img/icons/left-year-arrow.png) no-repeat;
		background-position: 20px;
		padding-left: 60px;
		cursor: pointer;
		transition-duration: 0.3s;
		&:hover {
			transition-duration: 0.3s;
			background: url(/lk/static/img/icons/left-year-arrow.png) no-repeat;
			background-position: 20px;
			padding-left: 60px;
		}
	}
</style>
